基础数据结构之数组的双指针技巧之对撞指针(两端向中间):三数之和(LeetCode 15 中等题)

**题目:**给你一个整数数组 nums ,判断是否存在三元组 nums\[i, numsj, numsk] 满足 i != j、i != k 且 j != k ,同时还满足 numsi + numsj + numsk == 0 。请你返回所有和为 0 且不重复的三元组。

**解题思路:**三层循环暴力法会得到重复结果,所以需要先排序去除重复。

双指针对撞也需要先排序,之后先固定一个初始值,之后需要俩数字和初始值结合起来为0,俩数字如何选择?可以通过第一个数字和最后一个数字加起来看跟目标值的对比,大了说明需要变小一点,那就移动大数那边的指针,否则,就移动小数那边的指针。其中,边界条件需要考虑:初始值一致或者双指针对应的俩数字跟相邻数字一致的话都会导致出现重复结果,需要进行排除。

python 复制代码
class Solution:
    def threeSum(self, nums: List[int]) -> List[List[int]]:
        # 预处理:先排序,避免三个值一致但顺序不同的情况出现
        nums.sort()
        result = []
        n = len(nums)
        for i in range(0,n-2):
            # 边界处理:i值一样的也需要跳过(已经处理过则跳过)
            if nums[i] == nums[i-1] and i > 0:
                continue
            # 先确定一个数,剩下两个数分别头尾指针开始对撞。根据和的大小决定哪个指针移动
            j = i + 1
            k = n - 1
            while j < k:
                target = nums[i]+nums[j]+nums[k]
                if target == 0:
                    result.append([nums[i],nums[j],nums[k]])
                    # 边界处理:j、k两侧一致的元素需要跳过(已经处理过则跳过)
                    while j < k and nums[j] == nums[j+1]:
                        j+=1
                    while j < k and nums[k] == nums[k-1]:
                        k-=1
                    # 同时移动前需要排除大小一致的元素,避免结果重复
                    j+=1
                    k-=1
                elif j < k and target<0:
                    j+=1
                elif j < k and target>0:
                    k-=1
                
        return result
相关推荐
Ada's2 小时前
【计算机基础系列】003:Python数据结构
开发语言·数据结构·python
Nil2083 小时前
leetcode 118杨辉三角
算法·leetcode·职场和发展
wanderist.5 小时前
线性筛法详解:从筛质数到欧拉函数、Möbius 函数与约数函数
java·数据结构·算法
All for pursuit.6 小时前
【设计-1】208.实现Trie (前缀树)
数据结构·c++·算法·leetcode
weixin_307779136 小时前
C++代码实现MATLAB中的crossval函数功能
开发语言·c++·算法·matlab
青少儿编程课堂6 小时前
背包问题(0/1 背包与完全背包)解题精讲——动态规划入门
c++·python·算法·bfs·信息学竞赛
光影少年6 小时前
为什么 JavaScript 中 0.1 + 0.2 !== 0.3,如何让其相等?
前端·javascript·算法
HEJOO97 小时前
Linux 设备驱动系列——使用全局工作队列
java·linux·算法
Code_Solitude7 小时前
c语言:递归
java·c语言·算法
程序员清风7 小时前
哈希表:从键值映射到高效查找
数据结构·哈希算法·散列表